<template>
  <div class="relative game__banner">
    <img
      :src="bannerImage.ImagePath"
      class="w-[750px] h-[590px] relative z-10"
      loading="lazy"
    />
    <img
      :src="
        getAssetImage(
          'assets/theme/light_flexible_1/desktop/images/home_game_background.png'
        )
      "
      class="w-[700px] h-[460px] absolute top-10 right-0"
      loading="lazy"
    />
    <lazy-theme-desktop-china-components-slide-fade-transition
      appear
      :duration="300"
    >
      <div class="flex flex-col gap-4 w-[460px] absolute right-0 top-[92px]">
        <img :src="bannerLogo.ImagePath" class="w-[415px] h-[116px]" />
        <p class="w-[415px] min-h-[72px] text-[16px] font-medium">
          {{ content.Text }}
        </p>
        <div class="relative z-20 w-full">
          <section class="w-[415px]">
            <swiper
              :slides-per-view="6"
              :modules="modules"
              :navigation="games.length > 6"
              class="swiper-wrapper game-swiper"
            >
              <template v-for="game in games" :key="game.GameId">
                <swiper-slide
                  v-if="game.GameType !== 'lobby'"
                  class="flex flex-col items-start w-4/12 swiper-slide"
                >
                  <nuxt-link
                    class="cursor-pointer game_tab group"
                    :to="`/games/${game.GameType}__n__gt`"
                  >
                    <img
                      class="w-[32px] h-[32px] block group-hover:hidden"
                      :src="game.IconForDisplay"
                      alt="logo"
                      loading="lazy"
                    />
                    <img
                      class="w-[32px] h-[32px] hidden group-hover:block"
                      :src="game.ActiveIconForDisplay"
                      alt="logo"
                      loading="lazy"
                    />
                  </nuxt-link>
                  <div
                    class="text-center py-3 h-fit text-[14px] w-[58px] font-medium break-words"
                  >
                    <span>{{ $t(game.DisplayName) }}</span>
                  </div>
                </swiper-slide>
              </template>
            </swiper>
          </section>
        </div>
      </div>
    </lazy-theme-desktop-china-components-slide-fade-transition>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import _ from "lodash";
import { Navigation } from "swiper";
import SlideFadeTransition from "../../SlideFadeTransition.client.vue";
import { GameBsi } from "@/models/bsiGameList";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";
import { gameStore } from "~~/store/game";

export default defineComponent({
  components: {
    SlideFadeTransition,
  },
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const games = computed(() =>
      _.uniqBy(
        gameStore.state.games
          .filter(
            (game) =>
              game.TabType.trim().toLowerCase() === "games" &&
              game.ForDesktop &&
              game.IsEnabled
          )
          .map((game) => new GameBsi(game)),
        "GameType"
      ).filter((item: any) => item.GameType !== "")
    );
    const bannerImage = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_5"
        )
    );
    const bannerLogo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_5_1"
        )
    );
    const content = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_content_5_1"
        )
    );
    const { getAssetImage } = commonHelper;
    return {
      games,
      bannerImage,
      bannerLogo,
      content,
      modules: [Navigation],
      getAssetImage,
    };
  },
});
</script>

<style scoped>
:deep(.game-swiper.swiper-wrapper) {
  padding-left: 11px;
  padding-right: 1px;
  transform: translate(-13px);
}
:deep(.game-swiper .swiper-button-prev) {
  translate: -10px -35px;
}
:deep(.game-swiper .swiper-button-next) {
  translate: 10px -36px;
}
</style>
